<?php
namespace Teknisa\PED\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Doctrine\ORM\EntityManager;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Libraries\PHPMailer;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\PED\Services\ped07700ParametrizacaoClientesPedidosService;

class ped07700ParametrizacaoClientesPedidosController extends TeknisaCrud {

    protected $dataSourceName = 'cliente_parametrizacao';
    protected $dataSourceNameToSave = '';
    protected $service; 
    protected $parameterBag;
    protected $entityManager;
    protected $connection;
    
    public function __construct($crudService, ParameterBag $parameterBag, EntityManager $entityManager, ped07700ParametrizacaoClientesPedidosService $service)
    {        
        $this->service = $service;
        $this->entityManager = $entityManager;
        $this->ped07700ParametrizacaoClientesPedidosService = $service;
        parent::__construct($crudService, $parameterBag);
        $this->connection = $entityManager->getConnection();
    }
    
    public function exportPrecos(Row $rows, Response $response) {
        $this->dataSourceNameToSave = 'tabpreclie_produto';
        $rows  = $rows->getRow();
    
        try {
            
            $this->service->geraProduto($rows);
            
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }
        
    }

    public function saveItem($rows, $request, $response, $oldCode) {
        $this->dataSourceNameToSave = 'itempedido_completa';
        for ($i = 0; $i < count($rows[2]); $i++) {
           for ($e = 0; $e < count($oldCode); $e++) {
                if ($rows[2][$i]['NRPEDIDO'] == $oldCode[$e]['CDANTIGO']) {
                    $rows[2][$i]['NRPEDIDO'] = $rows[0][$e]['NRPEDIDO'];
                }
           }
        }
        try {
            $dataSet = new DataSet ("data", $rows[2]->getArrayCopy());
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }

    }
    
    public function salvaDadosProduto(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        try{
            $this->connection->beginTransaction();
            
            $this ->service->deletaDados($row);
            $this->service->insertDados($row);
            
            $this->connection->commit();
        } catch (\Exception $e) {
             $this->entityManager->rollback();
             throw $e;
        }

    }
    
    public function deletaDadosProduto(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        try{
            $this->connection->beginTransaction();
            
            $this ->service->deletaDados($row);
            
            $this->connection->commit();
        } catch (\Exception $e) {
             $this->entityManager->rollback();
             throw $e;
        }

    }
    public function bkp(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        try{
            $this->connection->beginTransaction();
            
            $this ->service->deletaDados($row);
            
            $this->connection->commit();
        } catch (\Exception $e) {
             $this->entityManager->rollback();
             throw $e;
        }

    }
    public function salvarCadastramentoCliente($request, $response){
        $this->entityManager->getConnection()->beginTransaction();
        try{    
            $rowCadAuto = $request->getDataSet()->getRows()[0];
            $clientes = $request->getDataSet()->getRows()[1];
            
            $rowsToSave = array();
            foreach($clientes as $key => $cliente){
                
                // var_dump('variavel do front', $rowCadAuto['CDTIPTRANS']);die;
                
                // Vendedor
                $cliente['CDVENDEDOR'] = $rowCadAuto['CDVENDEDOR'] ? $rowCadAuto['CDVENDEDOR'] : $cliente['CDVENDEDOR'];
                
                // Modalidade de pagamento
                $cliente['CDMODPGTO'] = $rowCadAuto['CDMODPGTO'] ? $rowCadAuto['CDMODPGTO'] : $cliente['CDMODPGTO'];
                
                // Grupo de clientes
                $cliente['CDGRUPCLIE'] = $rowCadAuto['CDGRUPCLIE'] ? $rowCadAuto['CDGRUPCLIE'] : $cliente['CDGRUPCLIE'];
                
                // Região
                $cliente['CDREGIAOPED'] = $rowCadAuto['CDREGIAOPED'] ? $rowCadAuto['CDREGIAOPED'] : $cliente['CDREGIAOPED'];
                
                //desconto máximo
                $cliente['VRPEMAXDESCL'] = $rowCadAuto['VRPEMAXDESCL'] ? $rowCadAuto['VRPEMAXDESCL'] : $cliente['VRPEMAXDESCL'];
                
                // Dados da Transportadora
                $cliente['NRINSJURTRAN'] = $rowCadAuto['NRINSJURTRAN'] ? $rowCadAuto['NRINSJURTRAN'] : $cliente['NRINSJURTRAN'];
                $cliente['IDTPIJURTRAN'] = $rowCadAuto['IDTPIJURTRAN'] ? $rowCadAuto['IDTPIJURTRAN'] : $cliente['IDTPIJURTRAN'];
                $cliente['CDTIPTRANS'] = $rowCadAuto['CDTIPTRANS'] ? $rowCadAuto['CDTIPTRANS'] : $cliente['CDTIPTRANS'];
                $cliente['IDPGFRETTRANCLI'] = $rowCadAuto['IDPGFRETTRANCLI'] ? $rowCadAuto['IDPGFRETTRANCLI'] : $cliente['IDPGFRETTRANCLI'];

                
                $this->ped07700ParametrizacaoClientesPedidosService->salvarCadastramentoCliente($cliente);
    
            }
    
            $this->entityManager->getConnection()->commit();
            
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
            $this->entityManager->rollback();
        } 
    }
    

}