var Ped14000_parametrosWebservice_Controller = function(Ped14000_parametrosWebservice_Service, ScreenService, templateManager, Endereco, ZhFilterPreferences, General, ZHPromise, metaDataFactory, MessageService){
    
    this.openFilter = function(widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
    };
    this.setFilter = function(widget){
        var widgetcadAutoCliente  = templateManager.container.getWidget('cadAutoCliente');
        var widgetcadAutoProduto = templateManager.container.getWidget('cadAutoProduto');
        var widgetcadAutoModalidade = templateManager.container.getWidget('cadAutoModalidade');
        if (widget===widgetcadAutoCliente){
            widgetcadAutoCliente.currentRow.IDTPCADAUTOCLIE = 'T';
            //widgetcadAutoCliente.getField('IDTPCADAUTOCLIE').setValue ='T';
        }else if ( widget===widgetcadAutoProduto){
            widgetcadAutoProduto.currentRow.IDTPCADAUTOPROD = 'T';
            //widgetcadAutoProduto.getField('IDTPCADAUTPROD').setValue = 'T';
        }else if ( widget===widgetcadAutoModalidade){
            widgetcadAutoModalidade.currentRow.IDTPCADAUTOMOD = 'T';
            //widgetcadAutoModalidade.getField('IDTPCADAUTOMOD').setValue='T';
        }
        
    };
   this.openItens = function(widget){
        var widgetPedidos = templateManager.container.getWidget('widgetPedidos');
        var widgetItens = templateManager.container.getWidget('widgetItens');
        var widgetTabbed = templateManager.container.getWidget('widgetTabbed');
        var filter = [
            {
                "name": "P_NRPEDIDO",
                "operator": "=",
                "value": widgetPedidos.currentRow.NRPEDIDO
            },
            {
                "name": "P_NRITEMPED",
                "operator": "=",
                "value": "T"
            },
            {
                "name": "P_NRSEQWEBSERVICE",
                "operator": "=",
                "value": widgetPedidos.currentRow.NRSEQWEBSERVICE
            }
           
        ];
        widgetItens.activate();
        widgetTabbed.activate();
        widgetItens.dataSourceFilter = filter;
        ScreenService.openSwipe(widgetTabbed);
        widgetItens.reload();

        
        
    };

    this.disableField = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice');
        var widgetModalidade = templateManager.container.getWidget('widgetModPgto');
        var widgetProduto = templateManager.container.getWidget('widgetProdutos');
    
        
        if (widget === widgetWebservice){
            if (widget.currentRow.NRSEQWEBSERVICE != ""){
                widget.getField('NRSEQWEBSERVICE').readOnly = true;
            }else{
                widget.getField('NRSEQWEBSERVICE').readOnly = false;
            }
        }else if (widget === widgetModalidade){
            if (widget.currentRow.DSMODPGTO != ""){
                widget.getField('DSMODPGTO').readOnly = true;
            }else{
                widget.getField('DSMODPGTO').readOnly = false;
            }
        }else if (widget === widgetProduto){
            if (widget.currentRow.NMPRODUTO!= ""){
                widget.getField('NMPRODUTO').readOnly = true;
                widget.getField('NMPRODUTO').reload();
            }else{
                widget.getField('NMPRODUTO').readOnly = false;
                widget.getField('NMPRODUTO').reload();
            }
        }
    };
    
    this.salvaTabelasCliente = function(widget){
        var widgetCliente = templateManager.container.getWidget('widgetClientes');
        var data = {};
        
        var row = {};
        
        if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosCliePedWeb(data).then(function(success){
                row[0]={
                    CDCLIENTE: widget.currentRow.CDCLIENTE,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    
                    __is_new:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosClieWebSync(row).then(function(success){
                
                    ScreenService.showMessage('Cliente salvo com sucesso.');
                    ScreenService.closeSwipe();
                    widgetCliente.reload().then(function(){
                        widgetCliente.activate();
                    });
                
                });
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Cliente já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
            
        }else{
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosCliePedWeb(data).then(function(success){
                
                row[0]={
                    CDCLIENTE: widget.currentRow.CDCLIENTE,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    __is_new:false,
                    changed:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosClieWebSync(row).then(function(success){
                
               
                    ScreenService.showMessage('Cliente editado com sucesso.');
                    ScreenService.closeSwipe();
                    widgetCliente.reload().then(function(){
                        widgetCliente.activate();
                    });
                    
                }.bind(this));
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Cliente já cadastrado neste Webserice.');
                widget.reload();
                
            }.bind(this));
        }
    };
    this.validaCodigoSiteClie = function(widget){
        if(widget.isValid()){
            var codCliente = widget.currentRow.CDCLIENTE;
            var filterClie = [
                {
                    "name":"CDCLIENTE",
                    "operator":"=",
                    "value":widget.currentRow.CDCLIENTE
                }
            ];
            General.callRestEngine('ped#/crud/cliepedweb', 'FilterData', filterClie).then(function(callback){
                var codigos= callback.dataset.cliepedweb;
                var foundCliente = codigos.find(element=>element.CDCLIENTE === codCliente);
                
                if(foundCliente == undefined){
                    var codClieSite =widget.currentRow.CDCLIEEXTERNO;
                    var filterSite = [
                        {
                            "name": "CDCLIEEXTERNO",
                            "operator": "=",
                            "value": widget.currentRow.CDCLIEEXTERNO
                        }
                        
                    ];
                    General.callRestEngine('ped#/crud/cliepedweb', 'FilterData', filterSite).then(function(callback){
                        var codigos= callback.dataset.cliepedweb;
                        var foundSite = codigos.find(element=>element.CDCLIEEXTERNO == codClieSite);
            
                            if(foundSite != undefined){
                                var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outro cliente. Deseja continuar?");
                                ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                                label: ScreenService.i18n("Sim"),
                                code: function(){
                                    this.salvaTabelasCliente(widget);
                                }.bind(this)
                                },{
                                    label: ScreenService.i18n("Não"),
                                    code: function(){}.bind(this)
                                }]);
                                    
                            }else{
                                this.salvaTabelasCliente(widget);
                            }
                    }.bind(this));
                }else{
                    this.salvaTabelasCliente(widget);
                }
            }.bind(this));
        }
    };
    
    this.validaCodigoSiteProd = function(widget){
        if(widget.isValid()){
            var codProdSite =widget.currentRow.CDPRODEXTERNO;
            var codProduto =widget.currentRow.CDPRODUTO;
        
            var filterCdProd =[
                {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": widget.currentRow.CDPRODUTO
                }
                
            ];
            General.callRestEngine('ped#/crud/prodpedweb', 'FilterData', filterCdProd).then(function(callback){
                var codigos= callback.dataset.prodpedweb;
                var foundProduto = codigos.find(element=>element.CDPRODUTO === codProduto);
                
                if(foundProduto == undefined){
                     var filterCdSite = [
                        {
                            "name": "CDPRODEXTERNO",
                            "operator": "=",
                            "value": widget.currentRow.CDPRODEXTERNO
                        }
                    ];
                    General.callRestEngine('ped#/crud/prodpedweb', 'FilterData', filterCdSite).then(function(callback){
                        var codigos= callback.dataset.prodpedweb;
                        var foundCodSite = codigos.find(element=>element.CDPRODEXTERNO === codProdSite);
                        if(foundCodSite != undefined){
                            var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outro produto. Deseja continuar?");
                            ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                            label: ScreenService.i18n("Sim"),
                            code: function(){
                                this.salvaTabelasProduto(widget);
                            }.bind(this)
                            },{
                                label: ScreenService.i18n("Não"),
                                code: function(){}.bind(this)
                            }]);
                                
                        }else{
                            this.salvaTabelasProduto(widget);
                        }
                    }.bind(this));  
                }else{
                    this.salvaTabelasProduto(widget);
                }
            }.bind(this));
        }
    };
    
    this.salvaTabelasProduto = function(widget){
        var widgetProduto = templateManager.container.getWidget('widgetProdutos');
        var data = {};
         if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosProdPedWeb(data).then(function(success){
                
                var row = {};
                row[0]={
                    CDPRODUTO: widget.currentRow.CDPRODUTO,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTPROD: widget.currentRow.DTULTALTPROD,
                    DTULTATUPROD: widget.currentRow.DTULTATUPROD,
                    __is_new:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosProdWebSync(row).then(function(success){
                
                    ScreenService.closeSwipe();
                    ScreenService.showMessage('Produto Salvo com sucesso.');
                    widgetProduto.reload().then(function(){
                        
                        widgetProduto.activate();
                    });
                }.bind(this));
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Produto já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
        }else{
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosProdPedWeb(data).then(function(success){
                var row = {};
                
                row[0]={
                    CDPRODUTO: widget.currentRow.CDPRODUTO,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTPROD: widget.currentRow.DTULTALTPROD,
                    DTULTATUPROD: widget.currentRow.DTULTATUPROD,
                    __is_new:false,
                    changed:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosProdWebSync(row).then(function(success){
                
                    ScreenService.closeSwipe();
                    ScreenService.showMessage('Produto editado com sucesso.');
                    widgetProduto.reload().then(function(){
                        
                        widgetProduto.activate();
                    });
                }.bind(this));
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Produto já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
        }
    };
    this.openPopupCadastroCliente = function() {
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice').currentRow;
        var widgetcadAutoCliente = templateManager.container.getWidget('cadAutoCliente');
        widgetcadAutoCliente.currentRow.NRSEQWEBSERVICE = widgetWebservice.NRSEQWEBSERVICE;
        widgetcadAutoCliente.currentRow.DSWEBSERVICE = widgetWebservice.DSWEBSERVICE;
        widgetcadAutoCliente.currentRow.DSPRECOBASE = widgetWebservice.DSPRECOBASE;
        widgetcadAutoCliente.currentRow.CDPRECOBASE = widgetWebservice.CDPRECOBASE;
        widgetcadAutoCliente.isVisible = true;
        ScreenService.openPopup(widgetcadAutoCliente );
    };
    
    this.cancelarCadastroAutomatico = function() {
        var widget = templateManager.container.getActiveWidget();
        var widgetcadAutoCliente  = templateManager.container.getWidget('cadAutoCliente');
        var widgetcadAutoProduto = templateManager.container.getWidget('cadAutoProduto');
        var widgetcadAutoModalidade = templateManager.container.getWidget('cadAutoModalidade');


        if(widget === widgetcadAutoCliente){
            widgetcadAutoCliente.currentRow.IDTPCADAUTOCLIE = 'T';
            //widgetcadAutoCliente.getField('IDTPCADAUTOCLIE').setValue ='T';
            widgetcadAutoCliente.isVisible = false;
            this.disableFieldCadAuto();
            ScreenService.closePopup(widgetcadAutoCliente);
        }else if(widget === widgetcadAutoProduto){
            widgetcadAutoProduto.currentRow.IDTPCADAUTOPROD = 'T';
            //widgetcadAutoProduto.getField('IDTPCADAUTPROD').setValue = 'T';
            widgetcadAutoProduto.isVisible = false;
            this.disableFieldCadAuto();
            ScreenService.closePopup(widgetcadAutoProduto);
        }else if(widget === widgetcadAutoModalidade){ 
            widgetcadAutoModalidade.currentRow.IDTPCADAUTOMOD = 'T';
           // widgetcadAutoModalidade.getField('IDTPCADAUTOMOD').setValue='T';
            widgetcadAutoModalidade.isVisible = false;
            this.disableFieldCadAuto();
            ScreenService.closePopup(widgetcadAutoModalidade);
        }
    };
    this.disableFieldCadAuto = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetcadAutoCliente  = templateManager.container.getWidget('cadAutoCliente');
        var widgetcadAutoProduto = templateManager.container.getWidget('cadAutoProduto');
        var widgetcadAutoModalidade = templateManager.container.getWidget('cadAutoModalidade');
        if(widget === widgetcadAutoCliente){
            if (widget.currentRow.IDTPCADAUTOCLIE == 'T'){
                widget.getField('CDCLIENTE').readOnly = true;
                widget.getField('CDCLIENTE').clearValue();
                widget.getField('CDCLIENTE').reload();
            }else{
                widget.getField('CDCLIENTE').readOnly = false;
                widget.getField('CDCLIENTE').reload();
                
            }
        }else if (widget === widgetcadAutoProduto){
            if (widget.currentRow.IDTPCADAUTOPROD == 'T'){
                widgetcadAutoProduto.getField('NMPRODFIN').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').clearValue();
                widgetcadAutoProduto.getField('CDPRODUTO').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').readOnly = true;
                widgetcadAutoProduto.getField('NMPRODFIN').readOnly = true;
                widgetcadAutoProduto.getField('CDPRODUTO').readOnly = true;
                widgetcadAutoProduto.getField('NMPRODFIN').validations = {};
                widgetcadAutoProduto.getField('NMPRODINI').validations = {};
                widgetcadAutoProduto.getField('CDPRODUTO').validations = {};
                widgetcadAutoProduto.reload();
            }else if(widget.currentRow.IDTPCADAUTOPROD == 'I') {
                widgetcadAutoProduto.getField('CDPRODUTO').clearValue();
                widgetcadAutoProduto.getField('CDPRODUTO').readOnly = true;
                widgetcadAutoProduto.getField('CDPRODUTO').validations = {};
                widgetcadAutoProduto.getField('NMPRODFIN').validations = {required: true};
                widgetcadAutoProduto.getField('NMPRODINI').readOnly = false;
                widgetcadAutoProduto.getField('NMPRODINI').validations = {required: true};
                widgetcadAutoProduto.reload();
            }else if(widget.currentRow.IDTPCADAUTOPROD == 'L'){
                widgetcadAutoProduto.getField('NMPRODFIN').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').clearValue();
                widgetcadAutoProduto.getField('NMPRODINI').readOnly = true;
                widgetcadAutoProduto.getField('NMPRODFIN').readOnly = true;
                widgetcadAutoProduto.getField('CDPRODUTO').readOnly = false;
                widgetcadAutoProduto.getField('NMPRODFIN').validations = {};
                widgetcadAutoProduto.getField('NMPRODINI').validations = {};
                widgetcadAutoProduto.getField('CDPRODUTO').validations = {required:true};

            }
        }else if ( widget === widgetcadAutoModalidade){
            if (widget.currentRow.IDTPCADAUTOMOD == 'T'){
                widgetcadAutoModalidade.getField('CDMODPGTO').clearValue();
                widgetcadAutoModalidade.getField('CDMODPGTO').readOnly = true;
                widgetcadAutoModalidade.getField('CDMODPGTO').validations = {};
                widgetcadAutoModalidade.reload();
                
            }else{
                widgetcadAutoModalidade.getField('CDMODPGTO').readOnly = false;
                widgetcadAutoModalidade.getField('CDMODPGTO').validations = {required:true};
                widgetcadAutoModalidade.reload();
            }
        }
    };

    this.salvarCadastroAutomaticoCliente = function(widget) {
        var widgetCadAutoClie = templateManager.container.getWidget('cadAutoCliente');
        var IDTPCADAUTOCLIE =widgetCadAutoClie.currentRow.IDTPCADAUTOCLIE;
        var clientesLista = widgetCadAutoClie.currentRow.CDCLIENTE;
        var clientes = "";
        if (IDTPCADAUTOCLIE == 'L'){
            
            clientesLista.forEach(function(cliente){
                clientes += "_" +cliente;
            });
            clientes = clientes + "_";
        }
         
        var row = {};
        if(IDTPCADAUTOCLIE == 'T'){
            row[0]= {
                CDCLIENTE: IDTPCADAUTOCLIE,
                NRSEQWEBSERVICE: widgetCadAutoClie.currentRow.NRSEQWEBSERVICE
            };
        }else{
            
            row[0] = {
                CDCLIENTE: clientes,
                NRSEQWEBSERVICE: widgetCadAutoClie.currentRow.NRSEQWEBSERVICE
            };
        }
        if (widget.isValid()) {
            Ped14000_parametrosWebservice_Service.salvarCadastroAutomaticoCliente(row).then(function(response){
                var widgetCliente = templateManager.container.getWidget('widgetClientes');
                widgetCadAutoClie.isVisible = false;
                widgetCadAutoClie.currentRow = {};
                ScreenService.closePopup(widgetCadAutoClie);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetCliente.activate();
                widgetCliente.reload();
                widgetCadAutoClie.reload();
            },function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
        

    };
    
    this.openCadastroAutomaticoProdutos = function() {
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice').currentRow;
        var widgetCadAutoProd = templateManager.container.getWidget('cadAutoProduto');
        widgetCadAutoProd.currentRow.NRSEQWEBSERVICE= widgetWebservice .NRSEQWEBSERVICE;
        widgetCadAutoProd.currentRow.DSWEBSERVICE = widgetWebservice.DSWEBSERVICE;
        widgetCadAutoProd.currentRow.DSPRECOBASE = widgetWebservice.DSPRECOBASE;
        widgetCadAutoProd.currentRow.CDPRECOBASE = widgetWebservice.CDPRECOBASE;
        widgetCadAutoProd.isVisible = true;
        ScreenService.openPopup(widgetCadAutoProd);
    };
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
        
    };
    this.prodFin = function(widget){
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice');

        var row = widget.currentRow;
        widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widgetWebservice.currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetWebservice.currentRow.CDPRECOBASE
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    this.salvarCadastroAutomaticoProduto = function(widget) {
        var widgetCadAutoProd = templateManager.container.getWidget('cadAutoProduto');
        var IDTPCADAUTOPROD = widgetCadAutoProd.currentRow.IDTPCADAUTOPROD;
        var produtoLista = widgetCadAutoProd.currentRow.CDPRODUTO;
        var produtos = "";
        if (IDTPCADAUTOPROD == 'L'){
            
            produtoLista.forEach(function(produto){
                produtos += "_" +produto;
            });
            produtos = produtos+ "_";
        }
        
        var row = {};
        if(IDTPCADAUTOPROD == 'I'){
            row[0]= {
                CDPRODUTO: null,
                P_PRODINI :widgetCadAutoProd.currentRow.P_PRODINI,
                P_PRODFIN :widgetCadAutoProd.currentRow.P_PRODFIN,
                NRSEQWEBSERVICE: widgetCadAutoProd.currentRow.NRSEQWEBSERVICE,
                CDPRECOBASE: widgetCadAutoProd.currentRow.CDPRECOBASE

            };
        }else if (IDTPCADAUTOPROD == 'L'){
            
            row[0] = {
                CDPRODUTO : produtos,
                P_PRODINI :null,
                P_PRODFIN :null,
                NRSEQWEBSERVICE: widgetCadAutoProd.currentRow.NRSEQWEBSERVICE,
                CDPRECOBASE: widgetCadAutoProd.currentRow.CDPRECOBASE
            };
        }else if (IDTPCADAUTOPROD == 'T'){
            row[0] = {
                CDPRODUTO : IDTPCADAUTOPROD,
                P_PRODINI :null,
                P_PRODFIN :null,
                NRSEQWEBSERVICE: widgetCadAutoProd.currentRow.NRSEQWEBSERVICE,
                CDPRECOBASE: widgetCadAutoProd.currentRow.CDPRECOBASE
            };
        }
        
       if (widget.isValid()) {
            Ped14000_parametrosWebservice_Service.salvarCadastroAutomaticoProduto(row).then(function(response){
                var widgetProduto = templateManager.container.getWidget('widgetProdutos');
                widgetCadAutoProd.isVisible = false;
                widgetCadAutoProd.currentRow = {};
                widgetCadAutoProd.getField('NMPRODINI').readOnly = true;
                widgetCadAutoProd.getField('NMPRODFIN').readOnly = true;
                widgetCadAutoProd.getField('CDPRODUTO').readOnly = true;
                ScreenService.closePopup(widgetCadAutoProd);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetProduto.reload();
                widgetCadAutoProd.reload();
            },function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
        
        
    };
    
    this.validaCodigoSiteMod = function(widget){
        if(widget.isValid()){
            var codMod = widget.currentRow.CDMODPGTO;
            var filterMod = [
                {
                    "name": "CDMODPGTO",
                    "operator": "=",
                    "value": widget.currentRow.CDMODPGTO
                }
            ];
            General.callRestEngine('ped#/crud/modpedweb', 'FilterData', filterMod).then(function(callback){
                var codigos= callback.dataset.modpedweb;
                var foundMod = codigos.find(element=>element.CDMODPGTO == codMod);
                
                if(foundMod == undefined){
                    var codModSite =widget.currentRow.CDMODEXTERNO;
                    var filterSite = [
                        {
                            "name": "CDMODEXTERNO",
                            "operator": "=",
                            "value": widget.currentRow.CDMODEXTERNO
                        }
                    ];
                    
                    General.callRestEngine('ped#/crud/modpedweb', 'FilterData', filterSite).then(function(callback){
                        var codigos= callback.dataset.modpedweb;
                        var foundSite = codigos.find(element=>element.CDMODEXTERNO == codModSite);
            
                            if(foundSite != undefined){
                                var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outra modalidade. Deseja continuar?");
                                ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                                label: ScreenService.i18n("Sim"),
                                code: function(){
                                    this.salvaTabelasModalidade(widget);
                                }.bind(this)
                                },{
                                    label: ScreenService.i18n("Não"),
                                    code: function(){}.bind(this)
                                }]);
                                    
                            }else{
                                this.salvaTabelasModalidade(widget);
                            }
                    }.bind(this));  
                }else{
                    this.salvaTabelasModalidade(widget);
                }
            }.bind(this));   
        }
    };
    
    this.salvaTabelasModalidade = function(widget){
        var widgetModPgto = templateManager.container.getWidget('widgetModPgto');
        var data = {};
        if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosModPedWeb(data).then(function(success){
                ScreenService.showMessage('Modalidade salva com sucesso.');
                ScreenService.closeSwipe();
                widgetModPgto.activate();
                widgetModPgto.reload();
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível cadastrar. Modalidade já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this));
        }else{
            data[0]={
                CDMODPGTO:widget.currentRow.CDMODPGTO,
                CDMODEXTERNO:widget.currentRow.CDMODEXTERNO,
                NRSEQWEBSERVICE:widget.currentRow.NRSEQWEBSERVICE,
                __is_new:false,
                changed:true
               
            };
            Ped14000_parametrosWebservice_Service.salvaDadosModPedWeb(data).then(function(success){
                ScreenService.showMessage('Modalidade salva com sucesso.');
                ScreenService.closeSwipe();
                widgetModPgto.activate();
                widgetModPgto.reload();
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Modalidade já cadastrado neste Webservice.');
                widget.reload();
                
            }.bind(this)); 
        }
        
    };
    this.openCadastroAutomaticoModalidade = function() {
        var widgetWebservice = templateManager.container.getWidget('widgetWebservice').currentRow;
        var widgetCadAutoProd = templateManager.container.getWidget('cadAutoModalidade');
        widgetCadAutoProd.currentRow.NRSEQWEBSERVICE= widgetWebservice .NRSEQWEBSERVICE;
        widgetCadAutoProd.currentRow.DSWEBSERVICE = widgetWebservice.DSWEBSERVICE;
        widgetCadAutoProd.isVisible = true;
        ScreenService.openPopup(widgetCadAutoProd);
    };
    
    this.salvacadastroAutomaticoModalidade = function(widget){
        var widgetCadAutoMod = templateManager.container.getWidget('cadAutoModalidade');
        var IDTPCADAUTOMOD= widgetCadAutoMod.currentRow.IDTPCADAUTOMOD;
        var modalidadeLista = widgetCadAutoMod.currentRow.CDMODPGTO;
        var modalidades = "";
        if (IDTPCADAUTOMOD == 'L'){
            
           modalidadeLista.forEach(function(modalidade){
                modalidades += "_" +modalidade;
            });
            modalidades = modalidades+ "_";
        }
        
        var row = {};
        if(IDTPCADAUTOMOD == 'L'){
            row[0]= {
                CDMODPGTO: modalidades,
                NRSEQWEBSERVICE: widgetCadAutoMod.currentRow.NRSEQWEBSERVICE

            };
        }else if (IDTPCADAUTOMOD == 'T'){
            
            row[0] = {
                CDMODPGTO : IDTPCADAUTOMOD,
                NRSEQWEBSERVICE: widgetCadAutoMod.currentRow.NRSEQWEBSERVICE
            };
        }
        if (widget.isValid()) {
            Ped14000_parametrosWebservice_Service.salvarCadastroAutomaticoModalidade(row).then(function(response){
                var widgetModalidade = templateManager.container.getWidget('widgetModPgto');

                widgetCadAutoMod.isVisible = false;
                widgetCadAutoMod.currentRow = {};
                widgetCadAutoMod.getField('CDMODPGTO').readOnly = true;
                ScreenService.closePopup(widgetCadAutoMod);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetModalidade.reload();
                widgetCadAutoMod.reload();
            },function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
};  
    Configuration(function(ContextRegister){
    ContextRegister.register('Ped14000_parametrosWebservice_Controller', Ped14000_parametrosWebservice_Controller);
});