var  ped05900_composicao_preco_produto_Controller = function(ScreenService, ZhFilterPreferences, ped05900_composicao_preco_produto_Service, General, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, MessageService){
                                                            
    this.valor = '';
    this.position = [];

    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.setFilter = function(widget) {
        var filterRow = {};
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            templateManager.container.getActiveWidget().currentRow = filterRow;
        }.bind(this));
    };

    
    this.setDefaultTab = function(){
        var widget = templateManager.container.getWidget('widgetComposicao');
        widget.activate();
        widget.reload();
    };
    
    this.getOperadorLogado = function(){
        
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        return General.callRestEngine("ped#/crud/operador", 'FilterData', filter);
	};
    
    this.setDefaultValue = function(widget){
        widget.getField('NMITFORPRECO').readOnly = false;
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
    };
    
    this.editCompPreco = function(widget){
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('NMITFORPRECO').readOnly = true;
        General.edit(widget);
    };
    

    
    this.disableField = function(field){
        var widget = templateManager.container.getActiveWidget();
        if(field.name == "VRPEFORMPREC"){
            if(widget.currentRow.VRPEFORMPREC > 0 && widget.currentRow.VRPEFORMPREC < 100){
                widget.getField('VRFATFORMPREC').setValue('0');
                widget.currentRow.VRFATFORMPREC = 0;
            }
        } else if(field.name == "VRFATFORMPREC"){
            widget.getField('VRPEFORMPREC').setValue('0');
            widget.currentRow.VRPEFORMPREC = 0;
        }
        if(widget.currentRow.VRPEFORMPREC != 0 && widget.currentRow.VRFATFORMPREC == 0 ){
            if(widget.currentRow.VRPEFORMPREC > 100){
                
                ScreenService.showMessage('O Percentual de Composição do Preço do Produto não pode ser maior que 100.');
                widget.getField('VRPEFORMPREC'). setValue('0');
                
            }else if(widget.currentRow.VRPEFORMPREC <= 100 && widget.currentRow.VRPEFORMPREC > 0) {
                
                widget.getField('VRFATFORMPREC').setValue('0');
                widget.currentRow.VRFATFORMPREC = 0;
                widget.getField('VRFATFORMPREC').readOnly = true;
            }
        }else if (widget.currentRow.VRFATFORMPREC != 0 && widget.currentRow.VRPEFORMPREC == 0){
            widget.getField('VRPEFORMPREC').setValue('0');
            widget.currentRow.VRPEFORMPREC = 0;
            widget.getField('VRPEFORMPREC').readOnly = true;
        }else{
           widget.getField('VRPEFORMPREC').readOnly = false;
           widget.getField('VRFATFORMPREC').readOnly = false;
        }
    };
    /*global $*/
    this.openPopupformulaCalcPreco = function(widget){
        var widgetFormCalc = templateManager.container.getWidget('widgetFormCalc');
        var widgetFormula  = templateManager.container.getWidget('widgetFormula');
        
        widgetFormCalc.activate();
        widgetFormCalc.reload();
        
        ScreenService.openPopup(widgetFormCalc);
        widgetFormula.currentRow.DSFORMCALCPRECO= widget.dataSource.data[0].DSFORMCALCPRECO;
        //$(document).keydown(function(e) { return false; });
    };
    
    this.keyboardBlock = function(field){
        let input = document.querySelector("#DSFORMCALCPRECO");
        input.addEventListener("keypress", function(e) {
              e.preventDefault();
        });
    };
    
    this.closePopupFormula = function(){
        var widgetComposicao = templateManager.container.getWidget('widgetComposicao');
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        var fieldsForm = widgetFormula.fields;
        
        document.querySelector("#DSFORMCALCPRECO").value = "";

        fieldsForm.splice(3, fieldsForm.length);

        ScreenService.closePopup();
        widgetComposicao.activate();
        widgetFormula.reload();
        widgetComposicao.reload();
        templateManager.updateTemplate();
    };
    
    this.setDataSourceFilterApply = function(args){
        var widgetProduto = templateManager.container.getWidget('widgetProduto');
         if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter= [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                }
            ];
            
            widgetProduto.dataSourceFilter = dataSourceFilter;
            widgetProduto.currentRow.CDTIPOCUSTO = rowPopup.CDTIPOCUSTO;
            widgetProduto.currentRow.CDFILIAL = rowPopup.CDFILIAL;
            widgetProduto.reload();
         }
    };
    
    this.openWindowCalculo= function(){
        
        var widgetProduto = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto'].getWidget('widgetProduto');
        var tipoCusto = widgetProduto.currentRow.CDTIPOCUSTO;
        var filial = widgetProduto.currentRow.CDFILIAL;
        widgetProduto.deactivate();
        widgetProduto.isVisible = false;
         
        ScreenService.openWindow('ped_pedidos#ped05900_composicao_preco_produto_calc').then(function(){
            var widgetCalculoPreco = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto_calc'].getWidget('widgetCalculo');
            widgetCalculoPreco.activate();
            widgetCalculoPreco.isVisible = true;
            
            widgetCalculoPreco.getField('IDTPCALCPREBASE').setValue('T');
            widgetCalculoPreco.getField('CDPRECOBASE').readOnly = true;
            widgetCalculoPreco.currentRow.IDTPCALCPREBASE = "T";
            widgetCalculoPreco.currentRow.DTINIVALIPB = moment().format('DD/MM/YYYY');
            widgetCalculoPreco.getField('TTCDPRODUTO').setValue('I');
            widgetCalculoPreco.currentRow.TTCDPRODUTO = "I";
            widgetCalculoPreco.getField('NMPRODINI').readOnly = false;
            widgetCalculoPreco.getField('NMPRODINI').validations = {required: true};
            widgetCalculoPreco.currentRow.CDTIPOCUSTO = tipoCusto;
            widgetCalculoPreco.currentRow.CDFILIAL = filial;

        });
         
    };
    
    this.closeWindowCalculo = function(){
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var widgetListaCalc = templateManager.container.getWidget('listaCalcPreco');
        
        widgetCalculo.getField('NMPRODINI').clearValue();
        widgetCalculo.getField('NMPRODFIN').clearValue();
        widgetCalculo.currentRow.CDPRODUTOINI = "";
        widgetCalculo.currentRow.CDPRODUTOFIN = "";
        
        widgetCalculo.isVisible = false;
        widgetCalculo.deactivate();
        widgetListaCalc.dataSource.data = [];
        widgetCalculo.currentRow = {};
        widgetCalculo.reload();

        ScreenService.openWindow('ped_pedidos#ped05900_composicao_preco_produto').then(function(){
            
            var widgetProduto = templateManager.container.getWidget('widgetProduto');
            widgetProduto.isVisible = true;
            widgetProduto.activate();
            this.setDataSourceFilterApply();
            widgetProduto.reload();
        }.bind(this));
    };
    
    this.enableField = function(){
       var widgetCalculo = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto_calc'].getWidget('widgetCalculo');
       if(widgetCalculo.currentRow.IDTPCALCPREBASE == 'L'){
            widgetCalculo.getField('CDPRECOBASE').readOnly = false;
            widgetCalculo.getField('CDPRECOBASE').validations = {required:true};
       }else{
            widgetCalculo.getField('CDPRECOBASE').setValue("");
            widgetCalculo.currentRow.CDPRECOBASE = "";
            widgetCalculo.getField('CDPRECOBASE').readOnly = true;
            widgetCalculo.getField('CDPRECOBASE').validations = {};
       }
       
       if(widgetCalculo.currentRow.TTCDPRODUTO == 'I'){
           widgetCalculo.getField('NMPRODINI').readOnly = false;
           widgetCalculo.getField('NMPRODINI').validations = {required:true};
       }else{
            widgetCalculo.getField('NMPRODINI').setValue("");
            widgetCalculo.getField('NMPRODFIN').setValue("");
            widgetCalculo.currentRow.NMPRODINI = "";
            widgetCalculo.currentRow.NMPRODFIN = "";
            widgetCalculo.getField('NMPRODFIN').readOnly = true;
            widgetCalculo.getField('NMPRODINI').readOnly = true;
            widgetCalculo.getField('NMPRODINI').validations = {};
            this.setDataSourceFilter();
       }
       
       if(widgetCalculo.currentRow.NMPRODINI){
            widgetCalculo.getField('NMPRODFIN').readOnly = false;
            widgetCalculo.getField('NMPRODFIN').validations = {required:true};
       }else{
            widgetCalculo.getField('NMPRODFIN').readOnly = true;
            widgetCalculo.getField('NMPRODFIN').validations = {};
            widgetCalculo.getField('NMPRODFIN').setValue("");
            widgetCalculo.currentRow.NMPRODFIN = "";
       }
    };
    
    this.changeTipoCusto = function(){
        var widget = templateManager.container.getWidget('widgetCalculo');
        if(widget.currentRow.NMPRODINI){
            
            widget.getField('NMPRODINI').setValue("");
            widget.getField('NMPRODFIN').setValue("");
            widget.currentRow.NMPRODINI = "";
            widget.currentRow.NMPRODFIN = "";
            widget.getField('NMPRODFIN').readOnly = false;
            widget.getField('NMPRODFIN').readOnly = true;
            widget.getField('NMPRODINI').validations = {};
            this.setDataSourceFilter();
        }

    };
    
    this.setDataSourceFilter = function(){
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var widgetListaCalc = templateManager.container.getWidget('listaCalcPreco');
        
        var row = [];
        if(templateManager.container.getWidget('widgetCalculo').isValid()){
            if(widgetCalculo.currentRow.NMPRODFIN){
                if(widgetCalculo.currentRow.P_CDPRODUTOINI > widgetCalculo.currentRow.P_CDPRODUTOFIN){
                    ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                    widgetCalculo.getField('NMPRODFIN').setValue("");
                    return 0;
                }
            }
            
            
            if(widgetCalculo.currentRow.TTCDPRODUTO == 'I'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: widgetCalculo.currentRow.CDTIPOCUSTO,
                        CDFILIAL: widgetCalculo.currentRow.CDFILIAL,
                        CDARVPRODINI: widgetCalculo.currentRow.CDPRODUTOINI,
                        CDARVPRODFIN: widgetCalculo.currentRow.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        TTCDPRODUTO:null
                     }
                );
            }else{
                row.push(
                    {
                        CDPRODUTO: null,
                        TODOSLISTA: null,
                        CDTIPOCUSTO: widgetCalculo.currentRow.CDTIPOCUSTO,
                        CDFILIAL: widgetCalculo.currentRow.CDFILIAL,
                        CDARVPRODINI: null,
                        CDARVPRODFIN: null,
                        TTCDPRODUTO: widgetCalculo.currentRow.TTCDPRODUTO,
                        TCDPRODUTO:"T"
                    }
                );
            }
            
            ped05900_composicao_preco_produto_Service.openGridCalc(row).then(function(response){
                widgetListaCalc.dataSource.data = response.dataset.dataSetComp;
                widgetListaCalc.reload();
            });
        }else{
            widgetListaCalc.dataSource.data = [];
            widgetListaCalc.reload();
        }
    };
    
    this.createFields = function(){
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        var composicao = templateManager.container.getWidget('widgetComposicao').dataSource.data;
        var calculadora = templateManager.container.getWidget('widgetCalculadora');

        composicao.forEach(function(field){
            var newButtom = Object.assign({}, widgetFormula.getField('BUTTON_DEFAULT'));
            
            newButtom.name = field.SGITFORPRECO;
            newButtom.label = field.NMITFORPRECO;
            newButtom.isVisible = true;
            newButtom.showOnForm = true;
            newButtom.valueField = field.SGITFORPRECO; 
            newButtom.decriptionField = field.NMITFORPRECO;
            
            widgetFormula.fields.push(newButtom);
        });

        widgetFormula.activate();
        calculadora.activate();
        
        templateManager.updateTemplate();

    };

    this.setValueOnClick = function(field, widget){
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        templateManager.container.getWidget('widgetFormula').currentRow.DSFORMCALCPRECO = document.querySelector("#DSFORMCALCPRECO").value;
        var dsForm = document.querySelector("#DSFORMCALCPRECO");
        var text = widgetFormula.currentRow.DSFORMCALCPRECO;
        var selectStart = dsForm.selectionStart;
        var selectEnd = dsForm.selectionEnd;
        var leng = `${text.length}`;
        
        var textbefore = dsForm.value.substr( 0, selectStart);    
        var textafter = dsForm.value.substr( selectEnd, leng);

        if(widget.name == 'widgetFormula'){
            dsForm.value = textbefore + field.valueField + textafter;
            widgetFormula.getField('DSFORMCALCPRECO').setValue(dsForm.value );
            dsForm.focus();
            dsForm.selectionStart = selectStart + 2;
            dsForm.selectionEnd = selectEnd + 2;
        }else{
            dsForm.value = textbefore + field.valueField + textafter;
            widgetFormula.getField('DSFORMCALCPRECO').setValue(dsForm.value );
            dsForm.focus();
            dsForm.selectionStart = selectStart + 1;
            dsForm.selectionEnd = selectEnd + 1;
        }
        //document.querySelector("#DSFORMCALCPRECO").value += field.valueField;
    };

    this.backSpaceOnClick = function(field, widget){
        templateManager.container.getWidget('widgetFormula').currentRow.DSFORMCALCPRECO = document.querySelector("#DSFORMCALCPRECO").value;
        var dsForm = document.querySelector("#DSFORMCALCPRECO");
        var text = templateManager.container.getWidget('widgetFormula').currentRow.DSFORMCALCPRECO;
        var selectStart = dsForm.selectionStart;
        var selectEnd = dsForm.selectionEnd;
        var leng = `${text.length}`;
      
        var textbefore = dsForm.value.substr( 0, selectStart);    
        var textafter = dsForm.value.substr( selectEnd, leng);
        
        if(selectStart==selectEnd){
            dsForm.value = dsForm.value.substr(0, selectStart-1 ) + dsForm.value.substr(selectEnd, leng);
            document.querySelector("#DSFORMCALCPRECO").value = dsForm.value;
            dsForm.focus();
            dsForm.selectionStart = selectStart - 1;
            dsForm.selectionEnd = selectEnd - 1;

        }else {
            dsForm.value = textbefore + textafter ;
        }
        //document.querySelector("#DSFORMCALCPRECO").value = text.substr(0, text.length-1);

    };
    
    this.deleteOnClick = function(){

        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir toda  a fórmula?'), 'question', function (success) {
            document.querySelector("#DSFORMCALCPRECO").value = "";
        }.bind(this));
    };
    
    this.saveFormula = function(){
        var formula = templateManager.container.getWidget('widgetFormula');
        var produto = templateManager.container.getWidget('widgetProduto');
        var composicao = templateManager.container.getWidget('widgetComposicao');
        
        // seto variavel global valor antes de salvar a formula
        //this.valor = document.querySelector("#DSFORMCALCPRECO").value;
        
        // seto o valor do elemento na currentRow antes da validação da formula, retirando o custo de processamento do click
        formula.currentRow.DSFORMCALCPRECO = document.querySelector("#DSFORMCALCPRECO").value;
        
        var row = [{
          CDFILIAL: produto.currentRow.CDFILIAL,
          CDPRODUTO: produto.currentRow.CDPRODUTO,
          DSFORMCALCPRECO: formula.currentRow.DSFORMCALCPRECO 
        }];
        
        var validado = this.validationsForm(formula);
         
        if(validado){
            ped05900_composicao_preco_produto_Service.updateForm(row).then(function(response){
                ScreenService.showMessage('Fórmula salva com sucesso');
                formula.fields.splice(3, formula.fields.length);
                ScreenService.closePopup();
                composicao.activate();
                composicao.reload();
            });
        }
        
    };
    
    this.validationsForm = function(formula){
        var dsForm = formula.currentRow.DSFORMCALCPRECO;
        var strLength   = `${dsForm.length}`;
        var numeros     = ['1','2','3','4','5','6','7','8','9','0'];
        var dupSinais   = ['++','--','+*','*+','*-','-*','/*','/-','/+','+/','-/','*/'];
        var parenteses  = ['()','(/','(*','(-','(+','/)','*)','-)','+)',')('];
        var numParent   = [')1',')2',')3',')4',')5',')6',')7',')8',')9',
                         '1(','2(','3(','4(','5(','6(','7(','8(','9('];
        var subString = dsForm.substr(0,1);
        var ultCarater = dsForm[dsForm.length -1];
        var composicao  = [];
        var strDsForm   = [];
        var strCompForm =[]; 
        var filterParentese =[];
        var comParent = [];
        var compNum = [];
        var divisaoZero = ['/0'];
        var  validacao;
        var countParent = 0;

       
        formula.fields.forEach(function(field){
            numeros.forEach(function(num){
                if(field.name !='DSFORMCALCPRECO' && field.name !='BUTTON_DEFAULT'){
                    compNum.push(field.valueField.concat(num));
                    compNum.push(num.concat(field.valueField));
                }
            });
           if(field.name !='DSFORMCALCPRECO' && field.name !='BUTTON_DEFAULT'){
               comParent.push(field.valueField.concat('('));
               comParent.push(')'.concat(field.valueField));
               composicao.push(field.valueField);
               
           } 
        });
       
        for( var i = 0; i < strLength; i++ ){
            filterParentese.push(dsForm.substr(i, 1));
            strDsForm.push(dsForm.substr(i, 2));
            strCompForm.push(dsForm.substr(i, 3));

        }
        
        filterParentese.forEach(function(parentese){
            if(parentese == '('){
                countParent++;
            }else if(parentese == ')'){
                countParent--;
            }
        });
         
        
        var foundComp       = composicao.filter(a => strDsForm.includes(a));
        var foundCompNum    = compNum.filter(a => strCompForm.includes(a));
        var foundDivZero    = divisaoZero.filter(a => strDsForm.includes(a));
        var foundNumPar     = numParent.filter(a => strDsForm.includes(a));
        var foundCompPar    = comParent.filter(a => strCompForm.includes(a));
        var foundSinais     = dupSinais.filter(a => strDsForm.includes(a));
        var foundParenteses = parenteses.filter(a => strDsForm.includes(a));
        
        if(foundSinais.length > 0){
            ScreenService.showMessage('Fórmula incorreta. Sinais duplicados.');
            validacao = false;
        }else if(foundParenteses.length > 0){
            ScreenService.showMessage('Fórmula incorreta. Parentese utilizado de forma incorreta.');
            validacao = false;
        }else if(foundCompPar.length > 0){
            ScreenService.showMessage('Fórmula Incorreta. Deve-se conter um sinal entre a composição e o parêntesis.');
            validacao = false;
        }else if(foundNumPar.length > 0){
            ScreenService.showMessage('Fórmula incorreta. Deve-se conter um sinal entre o número  e o parentese.');
            validacao = false;
        }else if(foundDivZero.length > 0){
            ScreenService.showMessage('Fórmula incorreta. Divisão por zero.');
            validacao = false;
        }else if(foundCompNum.length > 0){
            ScreenService.showMessage('Fórmula incorreta. Deve-se conter um sinal entre o número  e a composição.');
            validacao = false;
        }else if(foundComp.length < composicao.length){
            ScreenService.showMessage('Necessário utilizar todas  as composições cadastradas na fórmula.');
            validacao = false;
        }else if(subString == '+' || subString == '-' || subString == '/' || subString == '*'){
            ScreenService.showMessage('Fórmula incorreta. A fórmula não pode iniciar com um sinal.');
            validacao = false;
        }else if(ultCarater == '+' || ultCarater == '-' || ultCarater == '/' || ultCarater == '*'){
            ScreenService.showMessage('Fórmula incorreta. A fórmula não pode terminar com um sinal.');
            validacao = false;
        }else if(countParent != 0){
            ScreenService.showMessage('Fórmula incorreta. Erro na abertura ou fechamento de parêntesis.');
            validacao = false;
        }
        else{
            validacao = true;
        }
        return validacao;
    };
    
    this.verifyChecked = function(){
        var widget = templateManager.container.getWidget('listaCalcPreco');
        var checkedRow = widget.selectedRow;
        var index = widget.getCheckedRows().indexOf(checkedRow);

        if(checkedRow.VRITEPREBASE < 0){
            
            widget.dataSource.checkedRows.splice(index, 1);
            checkedRow.__isSelected = false;
            ScreenService.showMessage('Produtos com valores negativos.');
        }
        
    };
    
    /*global moment*/
    this.calculaPrecoProd = function(){
        var dadosCalculo = templateManager.container.getWidget('widgetCalculo').currentRow;
        var produtosLista = templateManager.container.getWidget('listaCalcPreco').getCheckedRows();
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var widgetLista = templateManager.container.getWidget('listaCalcPreco');
        var hoje = moment().format('DD/MM/YYYY');
        var validade= dadosCalculo.DTINIVALIPB;
        var precoBase = "";
        var row = [];

        hoje = hoje.split("/").reverse("").join("/");
        var valInicial = validade.split("/").reverse("").join("/");
        

        this.getOperadorLogado().then(function(operador){
            var cdoperador = operador.dataset.operador[0].CDOPERADOR;

            if(dadosCalculo.IDTPCALCPREBASE == 'L'){
                precoBase = dadosCalculo.CDPRECOBASE;
    
            }else{
                precoBase = "T";
            }
            

            if(dadosCalculo.TTCDPRODUTO == 'I' && dadosCalculo.IDTPCALCPREBASE == 'L'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: dadosCalculo.CDPRODUTOINI,
                        CDARVPRODFIN: dadosCalculo.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: precoBase,
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO:null
                     }
                );
            }else if (dadosCalculo.TTCDPRODUTO == 'I' && dadosCalculo.IDTPCALCPREBASE == 'T'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: dadosCalculo.CDPRODUTOINI,
                        CDARVPRODFIN: dadosCalculo.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: "T",
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO: null
                    }
                );
            }else if (dadosCalculo.TTCDPRODUTO == 'T' && dadosCalculo.IDTPCALCPREBASE == 'L'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: dadosCalculo.CDPRODUTOINI,
                        CDARVPRODFIN: dadosCalculo.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: precoBase,
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO: "T"
                    }
                );
            }else{
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: null,
                        CDARVPRODFIN: null,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: "T",
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO: "T"
                    }
                );
        }
    
            row.push(produtosLista);
    
            if(templateManager.container.getWidget('widgetCalculo').isValid()){
                if(!(precoBase)){
                    ScreenService.showMessage("Preço base não informado.");
                }else
                if(!(validade)){
                    ScreenService.showMessage("Data de validade inicial não informada.");
                }else
                if(valInicial < hoje){
                    ScreenService.showMessage("Data Inválida. A data inicial não pode ser menor que a atual.");
                }else
                if (produtosLista.length == 0){
                    ScreenService.showMessage("Produto não informado.");
                }else{

                    ped05900_composicao_preco_produto_Service.calculaPrecoProd(row).then(function(response){
                    var result = response.dataset.dataSetCalc;
                    if(result.length == 0){
                        widgetCalculo.getField('NMPRODFIN').setValue("");
                        widgetLista.unSelectAll();
                        widgetLista.dataSource.data = [];
                        widgetLista.reload();
                        ScreenService.showMessage('Preço salvo com sucesso!');
                    }else{
                        var widgetErro = templateManager.container.getWidget('widgetErro');
                        var data = [];
                        ScreenService.openPopup(widgetErro);
                        result.forEach(function(res){
                            if(!(data.find( produto => produto.CDPRODUTO === res.CDPRODUTO))){
                                data.push(res);
                            }
                        });
                        widgetErro.dataSource.data = data;
                        widgetErro.reload();
                    }
                    
                });
                }
            }
        });    
    };

}; 

Configuration(function(ContextRegister){
    ContextRegister.register('ped05900_composicao_preco_produto_Controller', ped05900_composicao_preco_produto_Controller);
});                                                          