function ZhRichTextController($scope) {
	var self = this;
	var field = $scope.field;

	var toolbarDefaultOptions = {
		undo: true,
		redo: true,
		bold: true,
		italic: true,
		underline: true,
		superscript: true,
		subscript: true,
		strikethrough: true,
		clear: true,
		fontname: true,
		fontsize: true,
		color: true,
		ul: true,
		ol: true,
		paragraph: true,
		lineheight: true,
		table: true,
		picture: true,
		codeview: false
	};

	toolbarDefaultOptions = $.extend(toolbarDefaultOptions, field.toolbar || {});

	$scope.editorOptions = {
		height: field.height,
		dialogsInBody: true,
		lang: 'pt-BR',
		toolbar: [
			['edit',['undo','redo']],
			['style', ['bold', 'italic', 'underline', 'superscript', 'subscript', 'strikethrough', 'clear']],
			['fontface', ['fontname']],
			['textsize', ['fontsize']],
			['fontclr', ['color']],
			['alignment', ['ul', 'ol', 'paragraph', 'lineheight']],
			['table', ['table']],
			['insert', ['picture']],
			['view', ['codeview']]
		],
		callbacks:{				
			onInit: function() {
				$scope.onInitElement();
			},
			onChange: function() {
				$scope.onInitElement(arguments);
			}
		}
	};

	Object.keys(toolbarDefaultOptions).forEach(function(key) { 
		if (toolbarDefaultOptions[key] === false) {
			$scope.editorOptions.toolbar.forEach(function(group, index) {
				var groupButtons = group[1];
				var buttonIdx = groupButtons.indexOf(key);
				if (buttonIdx > -1) {
					groupButtons.splice(buttonIdx, 1);
				}
				if (groupButtons.length === 0) {
					$scope.editorOptions.toolbar.splice(index, 1);
				}
			});
		} 
	});
}
