function ModalidadePagamento() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Pedidos', 'Modalidade de Pagamento']);
		geral.esperarLoading();
	};

	this.adicionarModalidade = (codigo, modalidadePagamento, desconto, tipoRecebimento, formaPagamento,
		diaPagamento, parcelas, proximoMes, formaPagamento2) => {
		geral.fillField('CDMODPGTO', codigo);
		geral.fillField('DSMODPGTO', modalidadePagamento);
		geral.clickAndFllField('VRPEDESMODPG', desconto);
		geral.searchAndClickGridField('NMTIPORECE', tipoRecebimento, 'NMTIPORECE', '9009');
		geral.selectNative('IDTPFORPGTOMOD', formaPagamento);
		if (formaPagamento == 'Pagamento Fixo no Dia') {
			geral.fillField('NRDIAPGFIXMOD', diaPagamento);
			geral.fillField('NRPARCPGTOMOD', parcelas);
			geral.selectNative('IDUTDIAPAGMOD', proximoMes);
		} else {
			if (formaPagamento == 'Pela Forma de Pagamento') {
				geral.searchAndClickGridField('NMFORMPGTO', formaPagamento2, 'NMFORMPGTO', '9009');
			}
		}
	};

	this.editarModalidade = (modalidadePagamento, desconto, tipoRecebimento, formaPagamento,
		diaPagamento, parcelas, proximoMes, formaPagamento2) => {
		geral.fillField('DSMODPGTO', modalidadePagamento);
		geral.clickAndFllField('VRPEDESMODPG', desconto);
		z.field.select.clickCloseIcon('NMTIPORECE');
		geral.searchAndClickGridField('NMTIPORECE', tipoRecebimento, 'NMTIPORECE', '9009');
		geral.selectNative('IDTPFORPGTOMOD', formaPagamento);
		if (formaPagamento == 'Pagamento Fixo no Dia') {
			geral.fillField('NRDIAPGFIXMOD', diaPagamento);
			geral.fillField('NRPARCPGTOMOD', parcelas);
			geral.selectNative('IDUTDIAPAGMOD', proximoMes);
		} else {
			if (formaPagamento == 'Pela Forma de Pagamento') {
				geral.searchAndClickGridField('NMFORMPGTO', formaPagamento2, 'NMFORMPGTO', '9009');
			}
		}
	};
}

module.exports = new ModalidadePagamento();
